package com.SPIMasterDemo;

import android.app.Activity;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

import com.SPIMasterDemo.R.drawable;

public class SPIMasterDemoActivity extends Activity {
	/*declare a FT311 SPIMaster interface variable*/
    public FT311SPIMasterInterface spimInterface;
    /*graphical objects*/
    EditText readText;
    EditText writeText;
    EditText deviceAddressText,writeDeviceAddressText;
    EditText addressText,writeAddressText;
    EditText numBytesText;
    //AutoCompleteTextView freqText;
    EditText statusText,writeStatusText;
    EditText clockFreqText;
    
     
    
    
    Button readButton, writeButton;
    Button configButton, resetButton;
    
    Spinner clockPhaseSpinner;
    Spinner dataOrderSpinner;
    
    
    /*local variables*/
    byte[] readWriteBuffer;
    byte [] numReadWritten;
        
    byte numBytes;
    byte count;
    byte status;
    byte clockPhaseMode;
    byte dataOrderSelected;
    int clockFreq;
    
    
    /*parse the input values seperated by comma*/
    byte byteCount = 0;
	byte tempCount = 0;
	byte tempByte;
	byte [] tempBytes;
	String tempString;
    
   
    
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        /*create editable text objects*/
         
        readText = (EditText)findViewById(R.id.ReadValues);
        readText.setInputType(0);
        writeText = (EditText)findViewById(R.id.WriteValues);
      
               
        numBytesText = (EditText)findViewById(R.id.NumberOfBytesValue);
        
       
        statusText=(EditText)findViewById(R.id.StatusValues);
        statusText.setInputType(0);
        writeStatusText = (EditText)findViewById(R.id.WriteStatusValues);
        writeStatusText.setInputType(0);
        clockFreqText = (EditText)findViewById(R.id.ClockFreqValue);
        clockFreqText.setText("3000000");
         
        readButton = (Button)findViewById(R.id.ReadButton);
        writeButton = (Button)findViewById(R.id.WriteButton);
        configButton = (Button)findViewById(R.id.ConfigButton);
        resetButton = (Button)findViewById(R.id.resetButton);
        
        
        /*allocate buffer*/
        readWriteBuffer = new byte[64];
        numReadWritten = new byte[64];
        numReadWritten = new byte[1];
        tempBytes = new byte[3]; /*a byte can not be more than 3 digits, max 255*/
        /*default mode is set to mode 1*/
        clockPhaseMode = 1;
       
        
        clockPhaseSpinner = (Spinner)findViewById(R.id.ClockPhaseValue);
        ArrayAdapter<CharSequence> clockPhaseAdapter = ArrayAdapter.createFromResource(this,R.array.clock_phase, 
        																	android.R.layout.simple_spinner_item);
        
        clockPhaseSpinner.setAdapter(clockPhaseAdapter);
        clockPhaseSpinner.setSelection(1);
        
        
        /*data order*/
        /*default data order is set to MSB*/
        dataOrderSelected = 0;
        dataOrderSpinner = (Spinner)findViewById(R.id.DataOrderValue);
        ArrayAdapter<CharSequence> dataOrderAdapter = ArrayAdapter.createFromResource(this,R.array.data_order, 
        																	android.R.layout.simple_spinner_item);
        
        dataOrderSpinner.setAdapter(dataOrderAdapter);
        dataOrderSpinner.setSelection(dataOrderSelected);
        
        spimInterface = new FT311SPIMasterInterface(this);
        
        
        resetButton.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				resetButton.setBackgroundResource(drawable.start);
				// TODO Auto-generated method stub
				/*clear the receive and send edit boxes*/
				readText.setText("");
				writeText.setText("");
				numBytesText.setText("");
				writeStatusText.setText("");
				clockPhaseSpinner.setSelection(1);
				dataOrderSpinner.setSelection(0); // select MSB
				clockFreqText.setText("3000000");

				spimInterface.Reset();
				
			}
		});
        
        
        resetButton.setOnTouchListener(new View.OnTouchListener() {
			
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				// TODO Auto-generated method stub
				if(event.getAction()== MotionEvent.ACTION_DOWN)
						resetButton.setBackgroundResource(drawable.start1);
				return false;
			}
        });
        
        
        
        readButton.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				readButton.setBackgroundResource(drawable.start);
				numReadWritten[0] = 0x00;
				
				if(numBytesText.length() != 0)
				{
				
					numBytes = (byte)Integer.parseInt(numBytesText.getText().toString());
				
				
					for(count=0;count<numBytes;count++){
						readWriteBuffer[count]=(byte)0xff;
					}
				
					status = spimInterface.ReadData(numBytes, readWriteBuffer, numReadWritten);
								
					/*read the bytes from the text box*/
					char [] displayReadbuffer;
					displayReadbuffer = new char[64];
					int displayActualNumBytes;
					displayActualNumBytes = numReadWritten[0];

					for(count = 0;count<(numReadWritten[0]);count++){
					displayReadbuffer[count] = (char)readWriteBuffer[count];
					}
					readText.append(String.copyValueOf(displayReadbuffer, 0, displayActualNumBytes));
					
				}	
				statusText.setText(Integer.toString(numReadWritten[0]));
			}
		});
        
        readButton.setOnTouchListener(new View.OnTouchListener() {
			
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				// TODO Auto-generated method stub
				if(event.getAction()== MotionEvent.ACTION_DOWN)
						readButton.setBackgroundResource(drawable.start1);
				return false;
			}
        });
        
        
        /*handle write click*/
writeButton.setOnClickListener(new View.OnClickListener() {
	
	@Override
	public void onClick(View v) 
	{
		// TODO Auto-generated method stub
		writeButton.setBackgroundResource(drawable.start);
		
		numReadWritten[0] = 0x00;
		
		/*parse the string*/
		byteCount = 0;
		tempCount = 0;
		
		/*read the bytes from the write box*/
		if(writeText.length() != 0)
		{
		
			numBytes = (byte) writeText.length();
			
			byteCount = (byte)writeText.length();			
			for(count=0; count < byteCount; count++){
				readWriteBuffer[count] = (byte)writeText.getText().charAt(count);
			}
			
			/*send only when there is something to be send*/
			if(byteCount != 0x00)
				status = spimInterface.SendData(byteCount, readWriteBuffer, numReadWritten);
		}	
			writeStatusText.setText(Integer.toString(numReadWritten[0]));
			
	}
});

        writeButton.setOnTouchListener(new View.OnTouchListener() {
			
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				// TODO Auto-generated method stub
				if(event.getAction()==MotionEvent.ACTION_DOWN)
					writeButton.setBackgroundResource(drawable.start1);
				return false;
			}
		});
        
        
       /*config section*/ 
        configButton.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				configButton.setBackgroundResource(drawable.start);
				
				// TODO Auto-generated method stub
				if(clockFreqText.length() == 0x00)
				{
					clockFreqText.setText(Integer.toString(3000000));
					
				}
				
				clockPhaseMode = (byte)clockPhaseSpinner.getSelectedItemPosition();
				dataOrderSelected = (byte)dataOrderSpinner.getSelectedItemPosition();
				
				clockFreq = Integer.parseInt(clockFreqText.getText().toString());
				spimInterface.SetConfig(clockPhaseMode, dataOrderSelected, clockFreq);
			}
		});
        
        
        /*config button, set on touch listenere*/
        configButton.setOnTouchListener(new View.OnTouchListener() {
			
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				// TODO Auto-generated method stub
				if(event.getAction() == MotionEvent.ACTION_DOWN){
					configButton.setBackgroundResource(drawable.start1);
				}
				return false;
			}
		});
        
        
        
        
        
 }

    
   
    
        
     
    @Override
    protected void onResume() {
        // Ideally should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
        super.onResume();
        spimInterface.ResumeAccessory();
    }

    @Override
    protected void onPause() {
        // Ideally should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
        super.onPause();
        
       
  
    }
    
    @Override 
    protected void onDestroy(){
    	
    	//spimInterface.DestroyAccessory();
    	super.onDestroy();
    }

}